/*****************************************************************************/
/*                                                                           */
/*                              SOFTING AG                                   */
/*                        Richard-Reitzner-Allee 6                           */
/*                              D-85540 Haar                                 */
/*                      Phone: (++49)-(0)89-45656-0                          */
/*                      Fax:   (++49)-(0)89-45656-399                        */
/*                                                                           */
/*                  Copyright (C) SOFTING AG 1995-2004                       */
/*                                                                           */
/* See file CREDITS for list of people who contributed to this               */
/* project.                                                                  */
/*                                                                           */
/* This program is free software; you can redistribute it and/or             */
/* modify it under the terms of the GNU General Public License as            */
/* published by the Free Software Foundation; either version 2 of            */
/* the License, or (at your option) any later version.                       */
/*                                                                           */
/* This program is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston,                    */
/* MA 02111-1307, USA.                                                       */
/*                                                                           */
/* email: support.automation@softing.com                                     */
/* Softing AG, Richard-Reitzner-Allee 6, 85540 Haar, Germany                 */
/*                                                                           */
/*****************************************************************************/
/*****************************************************************************/
/*                                                                           */
/*  Author      : SOFTING                                                    */
/*                                                                           */
/*  CHANGE_NOTES                                                             */
/*                                                                           */
/*  date      name      change                                               */
/*  -----------------------------------------------------------------------  */
/*****************************************************************************/
/*****************************************************************************/

#include <stdarg.h>
#include <linux/string.h>
#include <linux/kernel.h>
#include "pb_debug.h"

#ifdef DEBUG
void DebugOut( unsigned int area, char *fmt, ... );

void (*DebugFnctn)( unsigned int area, char *fmt, ... )=DebugOut;
unsigned int DebugArea = 0;
//unsigned int DebugArea = (unsigned int) -1;

static char buf[1024];

void DebugOut( unsigned int area, char *fmt, ... )
{
  va_list args;

  if( area & DebugArea ) {
    va_start( args, fmt );
    vsprintf(buf, fmt, args);
    printk( buf );
    va_end( args );
  }
}

static int AsciiToHex( char *hex )
{
  unsigned int result=0;

  PR_DEBUG(D_ALL_L1,"AscciToHex( %s )\n", hex );
  for( ; *hex && *hex==' '; hex++ ) {
    ;
  }
  if( *(hex+1) == 'x' || *(hex+1) == 'X' ) // skip away 0x or 0X
    hex += 2;
  for( ; *hex && *hex!=' ' && *hex!='\n'; hex++ ) {
    result *= 16;
    if( *hex <= '9' )
      result += *hex-'0';
    else if( *hex <= 'F' )
      result += *hex-'A'+10;
    else
      result += *hex-'a'+10;
  }
  return( result );
}

int GetDebugFromString( char *DebugCmd )
{
  char *ptr = DebugCmd;

  if( strstr( DebugCmd, PRE_DEBUG_STRING ) ) {
    ptr += strlen(PRE_DEBUG_STRING);
    return( AsciiToHex( ptr ) );
  } else {
    return( 0 );
  }
}
#endif
