/*****************************************************************************/
/*                                                                           */
/*                              SOFTING AG                                   */
/*                        Richard-Reitzner-Allee 6                           */
/*                              D-85540 Haar                                 */
/*                      Phone: (++49)-(0)89-45656-0                          */
/*                      Fax:   (++49)-(0)89-45656-399                        */
/*                                                                           */
/*                  Copyright (C) SOFTING AG 1995-2004                       */
/*                                                                           */
/* See file CREDITS for list of people who contributed to this               */
/* project.                                                                  */
/*                                                                           */
/* This program is free software; you can redistribute it and/or             */
/* modify it under the terms of the GNU General Public License as            */
/* published by the Free Software Foundation; either version 2 of            */
/* the License, or (at your option) any later version.                       */
/*                                                                           */
/* This program is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston,                    */
/* MA 02111-1307, USA.                                                       */
/*                                                                           */
/* email: support.automation@softing.com                                     */
/* Softing AG, Richard-Reitzner-Allee 6, 85540 Haar, Germany                 */
/*                                                                           */
/*****************************************************************************/
/*****************************************************************************/
/*                                                                           */
/*  Author      : SOFTING                                                    */
/*                                                                           */
/*  CHANGE_NOTES                                                             */
/*                                                                           */
/*  date      name      change                                               */
/*  -----------------------------------------------------------------------  */
/*****************************************************************************/
/*****************************************************************************/

#ifndef _PB_HW_PCI_H_
#define _PB_HW_PCI_H_

#define REG_SIZE                  0x80
#define REG_SIZE_PCIE             0x100
#define IRQ_REGISTER              0x4c
#define CONTROL_REGISTER          0x50
#define GPIOC_9030                0x54

#define CHANNEL0                  0
#define CHANNEL1                  1

#define ENABLE_IRQ_CHANNEL_0      0x00000001
#define ENABLE_IRQ_CHANNEL_1      0x00000008
#define DISABLE_IRQ_CHANNEL_0     (~ENABLE_IRQ_CHANNEL_0)
#define DISABLE_IRQ_CHANNEL_1     (~ENABLE_IRQ_CHANNEL_1)

#define RUN_CHANNEL_0             0x00000020
#define RUN_CHANNEL_1             0x00000800
#define RESET_CHANNEL_0           (~RUN_CHANNEL_0)
#define RESET_CHANNEL_1           (~RUN_CHANNEL_1)

#define SET_IRQ_CHANNEL_0         0x00000004
#define SET_IRQ_CHANNEL_1         0x00000100
#define CLEAR_IRQ_CHANNEL_0       (~SET_IRQ_CHANNEL_0)
#define CLEAR_IRQ_CHANNEL_1       (~SET_IRQ_CHANNEL_1)

/*--- pci board identifiers --------------------------------------------------*/
#define PLX_VENDOR_ID         0x10B5
#define PLX_9050_DEVICE_ID    0x9050
#define PLX_9030_DEVICE_ID    0x9030
#define PLX_86E1_DEVICE_ID    0x86E1

// Offsets of PCI Local Configuration Registers (LCR) defined in DWORD units
#define _86E1_INTCSR              0x68     // Interrupt Control/Status register
#define _86E1_HALT                0x7FFF8
#define _86E1_RESET               0x7FFFA


// Bit definitions in LCRs
#define _86E1_RESET_XC161     0x0001
#define _86E1_RUN_XC161       0x0001
#define _86E1_EN_IRQ          0x00000900   // EN-IRQ-BIT channel 0/1 in INTCSR register

#define SOFTING_VENDOR_ID     0x14A0

// PROFIBUS ASIC's
#define ASIC_ASPC2                 0x01 // master only
#define ASIC_SPC3                  0x02 // slave only
#define ASIC_ASPC2_SPC3            0x03 // slave and master

#define GET_DO               0x08000000

#ifdef PB_ISA_SUPPORT
#define disable_pcie_irq(a)
#else
void disable_pcie_irq(struct CntrlExt *CtrlExt);
#endif


#endif // _PB_HW_PCI_H_

