/*****************************************************************************/
/*                                                                           */
/*                              SOFTING AG                                   */
/*                        Richard-Reitzner-Allee 6                           */
/*                              D-85540 Haar                                 */
/*                      Phone: (++49)-(0)89-45656-0                          */
/*                      Fax:   (++49)-(0)89-45656-399                        */
/*                                                                           */
/*                  Copyright (C) SOFTING AG 1995-2004                       */
/*                                                                           */
/* See file CREDITS for list of people who contributed to this               */
/* project.                                                                  */
/*                                                                           */
/* This program is free software; you can redistribute it and/or             */
/* modify it under the terms of the GNU General Public License as            */
/* published by the Free Software Foundation; either version 2 of            */
/* the License, or (at your option) any later version.                       */
/*                                                                           */
/* This program is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston,                    */
/* MA 02111-1307, USA.                                                       */
/*                                                                           */
/* email: support.automation@softing.com                                     */
/* Softing AG, Richard-Reitzner-Allee 6, 85540 Haar, Germany                 */
/*                                                                           */
/*****************************************************************************/
/*****************************************************************************/
/*                                                                           */
/*  Author      : SOFTING                                                    */
/*                                                                           */
/*  CHANGE_NOTES                                                             */
/*                                                                           */
/*  date      name      change                                               */
/*  -----------------------------------------------------------------------  */
/*****************************************************************************/
/*****************************************************************************/

#ifndef PB_IOCTL_H
#define PB_IOCTL_H

#pragma pack(push,1)
typedef struct _StatusAndData {
  void *StatusImage;
  int StatusLength;
  void *Data;
  int DataLength;
} StatusAndData;

typedef struct _NTIoctl {
  void *InBuf;
  int InBufLength;
  void *OutBuf;
  int OutBufLength;
} NTIoctl;

typedef struct _DataImage {
  int id;
  void *Buf;
  unsigned short Length; // sizeof( Buf )
} DataImage;

#pragma pack(pop)

// IOCTL-Magic for Softing-PROFIBUS is 0x69
#define IOCTL_PROFI_GET_DPRAM      0x6901
#define IOCTL_PROFI_SET_TIMEOUT    0x6902
#define IOCTL_PROFI_OPTIMIZED_MODE 0x6903
#define IOCTL_PROFI_SERIAL_NUMBER  0x6904
#define IOCTL_PROFI_STATUS_DATA    0x6905
#define IOCTL_PROFI_GET_DATA_IMAGE 0x6906
#define IOCTL_PROFI_SET_SLAVE_IN   0x6907
#define IOCTL_PROFI_DP_OPERATE     0x6908
#define IOCTL_PROFI_SET_DEBUGLEVEL 0x6909

#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,32)
long pb_ioctl( struct file *file, unsigned int cmd, unsigned long arg ); 
#else
int pb_ioctl( struct inode *inode, struct file *file, unsigned int cmd,
              unsigned long arg );
#endif


#endif
