/*****************************************************************************/
/*                                                                           */
/*                              SOFTING AG                                   */
/*                        Richard-Reitzner-Allee 6                           */
/*                              D-85540 Haar                                 */
/*                      Phone: (++49)-(0)89-45656-0                          */
/*                      Fax:   (++49)-(0)89-45656-399                        */
/*                                                                           */
/*                  Copyright (C) SOFTING AG 1995-2004                       */
/*                                                                           */
/* See file CREDITS for list of people who contributed to this               */
/* project.                                                                  */
/*                                                                           */
/* This program is free software; you can redistribute it and/or             */
/* modify it under the terms of the GNU General Public License as            */
/* published by the Free Software Foundation; either version 2 of            */
/* the License, or (at your option) any later version.                       */
/*                                                                           */
/* This program is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston,                    */
/* MA 02111-1307, USA.                                                       */
/*                                                                           */
/* email: support.automation@softing.com                                     */
/* Softing AG, Richard-Reitzner-Allee 6, 85540 Haar, Germany                 */
/*                                                                           */
/*****************************************************************************/
/*****************************************************************************/
/*                                                                           */
/*  Author      : SOFTING                                                    */
/*                                                                           */
/*  CHANGE_NOTES                                                             */
/*                                                                           */
/*  date      name      change                                               */
/*  -----------------------------------------------------------------------  */
/* IF YOU CHANGE SOMETHING ON THE OUTPUT, DON'T FORGET TO CHANGE             */
/* xml2html.c                                                                */
/*****************************************************************************/
/*****************************************************************************/

#include "basetypes.h"
#include <linux/mm.h>
#include <linux/sched.h>
#include "kernel_version.h"

#if ((VERSION_CODE(2,0,0) <= LINUX_VERSION_CODE) && \
     (LINUX_VERSION_CODE < VERSION_CODE(2,3,0)) )
#include <linux/proc_fs.h>
#include "cntrl.h"
#include "cmi.h"
#include "xx_if.h"

extern char *Version;
extern char *Copyright;

void StatisticTimer( unsigned long arg )
{
  struct timer_list *timer = (struct timer_list *)arg;
  int i;

  init_timer( timer );
  timer->expires = jiffies + HZ;
  add_timer( timer );
  for( i=0; i<PB_MAX_NR_BOARDS; i++ ) {
    if( CtrlExt[i].Service.Calls > CtrlExt[i].Service.Max )
      CtrlExt[i].Service.Max = CtrlExt[i].Service.Calls;
    CtrlExt[i].Service.CallsPerSecond = CtrlExt[i].Service.Calls;
    CtrlExt[i].Service.Calls = 0;
    if( CtrlExt[i].Data.Calls > CtrlExt[i].Data.Max )
      CtrlExt[i].Data.Max = CtrlExt[i].Data.Calls;
    CtrlExt[i].Data.CallsPerSecond = CtrlExt[i].Data.Calls;
    CtrlExt[i].Data.Calls = 0;
  }
}

static int pb_read_procmem( char *buf, char **start, off_t offset,
  int len, int unused)
{
  int i, NrOfBoards, length=0;

  // count nr of boards, don't change i afterwards
  for( NrOfBoards=0; NrOfBoards<PB_MAX_NR_BOARDS; NrOfBoards++ ) {
    if( CtrlExt[NrOfBoards].port==0 )
      break;
  }
  // fieldbus section
  length += sprintf( buf+length,
    "<fieldbus>\n\t<number of boards> %d </number of boards>\n",NrOfBoards);
  length += sprintf( buf+length,
    "<!-- %s -->\n", Copyright );
  length += sprintf( buf+length,
    "\t<driver version> %s </driver version>\n", Version);

  // node section
  for( i=0; i<PB_MAX_NR_BOARDS && CtrlExt[i].port; i++ ) {
    length+=sprintf(buf+length,
      "\t<node>\n\t\t<number> %d </number>\n", i );
    length+=sprintf(buf+length,
      "\t\t<port> 0x%x </port>\n", CtrlExt[i].port );
    length+=sprintf(buf+length,
      "\t\t<interrupt> %d </interrupt>\n", CtrlExt[i].interrupt );
    length+=sprintf(buf+length,
      "\t\t<mem> 0x%lx </mem>\n", CtrlExt[i].DprAddr );
    length+=sprintf(buf+length,
      "\t\t<irq count> %ld </irq count>\n", CtrlExt[i].NrIrqs );
    length+=sprintf(buf+length,
        "\t\t<type> PROFIboard </type>\n" );
    length+=sprintf(buf+length,
        "\t\t<serial number> %d </serial number>\n",
        CtrlExt[i].SerialNumber);
    length+=sprintf(buf+length,
      "\t\t<firmware version> %s </firmware version>\n",
      CtrlExt[i].FWVersion);
    /****************/
    /* Board Device */
    /****************/
    length+=sprintf(buf+length,
      "\t\t<board device><name> /dev/pbboard%d </name>\n", i);
    length+=sprintf(buf+length, "\t\t\t<status> %d/%d </status>",
      CtrlExt[i].Board.InUseCountRead, CtrlExt[i].Board.InUseCountWrite);
    length+=sprintf(buf+length,
      "</board device>\n");
    /******************/
    /* Service Device */
    /******************/
    length+=sprintf(buf+length,
    "\t\t<service device><name> /dev/pbservice%d </name>\n", i);
    length+=sprintf(buf+length,
      "\t\t\t<calls per second> %d </calls per second>\n",
      CtrlExt[i].Service.CallsPerSecond );
    length+=sprintf(buf+length, "\t\t\t<max calls> %d </max calls>\n",
      CtrlExt[i].Service.Max );
    length+=sprintf(buf+length, "\t\t\t<status> %d/%d (%d)</status>",
      CtrlExt[i].Service.InUseCountRead,
      CtrlExt[i].Service.InUseCountWrite,CtrlExt[i].Service.CMIClosed);
    length+=sprintf(buf+length,
      "</service device>\n");
    /***************/
    /* Data Device */
    /***************/
    length+=sprintf(buf+length,
      "\t\t<data device><name> /dev/pbdata%d </name>\n", i);
    length+=sprintf(buf+length,
      "\t\t\t<calls per second> %d </calls per second>\n",
      CtrlExt[i].Data.CallsPerSecond );
    length+=sprintf(buf+length, "\t\t\t<cycles> %ld </cycles>\n",
      CtrlExt[i].Data.Cycles );
    length+=sprintf(buf+length, "\t\t\t<max calls> %d </max calls>\n",
      CtrlExt[i].Data.Max );
    length+=sprintf(buf+length, "\t\t\t<status> %d/%d </status>\n",
      CtrlExt[i].Data.InUseCountRead, CtrlExt[i].Data.InUseCountWrite);
    length+=sprintf(buf+length,"\t\t\t<mode> %s </mode>",
      CtrlExt[i].Data.OptimizedMode? "OPTIMIZED" : "NORMAL" );
    length+=sprintf(buf+length,
      "</data device>\n");
    /**********************/
    /* Slave Input Device */
    /**********************/
    length+=sprintf(buf+length,
      "\t\t<slave input device><name> /dev/pbslin%d </name>\n", i);
    length+=sprintf(buf+length, "\t\t\t<status> %d/%d </status>\n",
      CtrlExt[i].SlaveIn.InUseCountRead,
      CtrlExt[i].SlaveIn.InUseCountWrite);
    length+=sprintf(buf+length,
      "</slave input device>\n");
    /***********************/
    /* Slave Output Device */
    /***********************/
    length+=sprintf(buf+length,
      "\t\t<slave output device><name> /dev/pbslout%d </name>\n", i);
    length+=sprintf(buf+length, "\t\t\t<status> %d/%d </status>\n",
      CtrlExt[i].SlaveOut.InUseCountRead,
      CtrlExt[i].SlaveOut.InUseCountWrite);
    length+=sprintf(buf+length, "\t\t\t<cycles> %ld </cycles>\n",
      CtrlExt[i].SlaveOut.Cycles );
    length+=sprintf(buf+length,
      "</slave output device>\n");

    // end of node section
    length+=sprintf(buf+length,
        "\t</node>\n");
  }

  length += sprintf( buf+length,"</fieldbus>\n");
  return( length );
}

struct proc_dir_entry profiboard_entry = {
  0,          // low_ino: the inode--dynamic
  10, "profiboard", // len of name and name
  S_IFREG | S_IRUGO,  // mode
  1, 0, 0,      // nlinks, owner, group
  0,          // size--unused
  NULL,       // operations--use default
  &pb_read_procmem, // function used to read data
};
#endif
