/*****************************************************************************/
/*                                                                           */
/*                              SOFTING AG                                   */
/*                        Richard-Reitzner-Allee 6                           */
/*                              D-85540 Haar                                 */
/*                      Phone: (++49)-(0)89-45656-0                          */
/*                      Fax:   (++49)-(0)89-45656-399                        */
/*                                                                           */
/*                  Copyright (C) SOFTING AG 1995-2004                       */
/*                                                                           */
/* See file CREDITS for list of people who contributed to this               */
/* project.                                                                  */
/*                                                                           */
/* This program is free software; you can redistribute it and/or             */
/* modify it under the terms of the GNU General Public License as            */
/* published by the Free Software Foundation; either version 2 of            */
/* the License, or (at your option) any later version.                       */
/*                                                                           */
/* This program is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston,                    */
/* MA 02111-1307, USA.                                                       */
/*                                                                           */
/* email: support.automation@softing.com                                     */
/* Softing AG, Richard-Reitzner-Allee 6, 85540 Haar, Germany                 */
/*                                                                           */
/*****************************************************************************/
/*****************************************************************************/
/*                                                                           */
/*  Author      : SOFTING                                                    */
/*                                                                           */
/*  CHANGE_NOTES                                                             */
/*                                                                           */
/*  date      name      change                                               */
/*  -----------------------------------------------------------------------  */
/*****************************************************************************/
/*****************************************************************************/

#ifndef _PB_TAR_H
#define _PB_TAR_H

#define D_BLOCK_SIZE     512
#define D_NAME_LENGTH    100
#define D_UNAME_LENGTH    32
#define D_GNAME_LENGTH    32
#define D_SPARSE_EXT_HDR  21
#define D_SPARSE_IN_HDR    4

#define D_END_OF_ARCHIVE   2

// Tar headers start on block boundaries

/******************************************************************/
/* The datastructure definition has been directly copied from the */
/* tar sources (version 1.11.8).                                  */
/******************************************************************/
struct sparse {
  char offset[12];
  char numbytes[12];
};

union record {
    unsigned char charptr[D_BLOCK_SIZE];
  struct header {
    char arch_name[D_NAME_LENGTH];
    char mode[8];
    char uid[8];
    char gid[8];
    char size[12];
    char mtime[12];
    char chksum[8];
    char linkflag;
    char arch_linkname[D_NAME_LENGTH];
    char magic[8];
    char uname[D_UNAME_LENGTH];
    char gname[D_GNAME_LENGTH];
    char devmajor[8];
    char devminor[8];

    /* The following fields were added for GNU and are not standard.  */
    char atime[12];
    char ctime[12];
    char offset[12];
    char longnames[4];
    /* Some compilers would insert the pad themselves, so pad was
       once autoconfigured.  It is simpler to always insert it!  */
    char pad;
    struct sparse sp[D_SPARSE_IN_HDR];
    char isextended;
    char realsize[12];  /* true size of the sparse file */
#if 0
    char ending_blanks[12]; /* number of nulls at the end of the file,
             if any */
#endif
  } header;

    struct extended_header {
    struct sparse sp[21];
    char isextended;
  }
    ext_hdr;
};

#endif
