/*****************************************************************************/
/*                                                                           */
/*                                SOFTING AG                                 */
/*                         Richard-Reitzner-Allee 6                          */
/*                               D-85540 Haar                                */
/*                       Phone: ++49-89-4 56 56-0                            */
/*                         Fax: ++49-89-4 56 56-3 99                         */
/*                                                                           */
/*                     Copyright (C) SOFTING AG 1998-2003                    */
/*                            All Rights Reserved                            */
/*                                                                           */
/*****************************************************************************/
/*****************************************************************************/
/*                                                                           */
/*  Filename    : DPSPROFI.H                                                 */
/*  Version     : 1.20                                                       */
/*  Date        : 30-04-2000                                                 */
/*  Author      : SOFTING AG                                                 */
/*                                                                           */
/*  Description : This file contains the structures, types and constants of  */
/*                DPSDemo                                                    */
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
/*****************************************************************************/
/*****************************************************************************/

#ifndef __DPSPROFI__
#define __DPSPROFI__

/****************************************************************************/
/*** DEFINES ****************************************************************/
/****************************************************************************/

/****************************************************************************/
/*** TYPES ******************************************************************/
/****************************************************************************/

typedef union _T_DPSPROFI_CON_IND
{
  T_DPS_CON_IND               dps_con_ind;
  T_DPS_INIT_SLAVE_CON        dps_init_con;
  T_DPS_EXIT_SLAVE_CON        dps_exit_con;
  T_DPS_GET_STATUS_CON_IND    dps_get_status_con_ind;
  T_DPS_SLAVE_DIAG_CON        dps_diag_con;
  T_DPS_CHK_CFG_IND           dps_chk_cfg_ind;
  T_DPS_SET_PRM_IND           dps_set_prm_ind;
  T_DPS_SET_SLAVE_ADD_IND     dps_set_slave_add_ind;

} T_DPSPROFI_CON_IND;

typedef enum
{
  STOPPED = 0,
  RUNNING,
  STOP_REQUEST
  
} T_THREAD_STATE;

/****************************************************************************/
/*** FUNCTION ***************************************************************/
/****************************************************************************/

FUNCTION extern PB_BOOL dpsprofi_init
  (
  IN    USIGN8          board,
  IN    USIGN8          slave_add
  )
  /*------------------------------------------------------------------------*/
  /* FUNCTIONAL_DESCRIPTION                                                 */
  /*------------------------------------------------------------------------*/
  /* - initializes this module                                              */
  /*------------------------------------------------------------------------*/
;

FUNCTION extern VOID dpsprofi_exit
  (
  IN    VOID
  )
  /*------------------------------------------------------------------------*/
  /* FUNCTIONAL_DESCRIPTION                                                 */
  /*------------------------------------------------------------------------*/
  /* - terminates this module                                               */
  /*------------------------------------------------------------------------*/
;

#endif /* __DPSPROFI__ */

/*** END OF DPSProfi.c ******************************************************/
